> For the complete documentation index, see [llms.txt](https://docs.specifyapp.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.specifyapp.com/reference/sdtf-engine/sdtf-queryresult.md).

# SDTF QueryResult

The QueryResult class provides an abstraction to work with the tree node returned by a SDTF query.

## Properties

### isContinuous

Indicates whether the selected nodes are part of the same resulting JSON tree.

```typescript
get isContinuous(): boolean;
```

## Methods

### merge

Produces a new tree state with the resulting nodes.

```typescript
merge(dedupeFn?: MergeDedupeFn): {
    treeState: TreeState;
};
```

### hasNodeType

Check if the result contains some nodes of the specified type.

```typescript
hasNodeType(nodeType: 'collection' | 'group' | 'token'): boolean;
```

### hasOnlyNodeType

Check if the result contains only nodes of the specified type.

```typescript
hasOnlyNodeType(nodeType: 'collection' | 'group' | 'token'): boolean;
```

### render

Produces an analysis of the resulting nodes.

```typescript
type QueryResultDetail = {
  isRoot: boolean;
  parentPath: Array<string>;
  isComplete: boolean;
  nodes: Array<SDTFNodeState>;
  sdtf: SpecifyDesignTokenFormat;
};
render(): Array<QueryResultDetail>;
```

{% hint style="info" %}
When the result is continuous, the render function returns an array of length 1
{% endhint %}

### getPaths

Get the token tree path of the resulting nodes.

```typescript
getPaths(type: 'string'): Array<string>;
getPaths(type: 'array'): Array<Array<string>>;
getPaths(type?: undefined): Array<string>;
```

### toJSON

Renders the resulting nodes as a JSON object using the QueryResultDetail structure.

```typescript
toJSON(): {
    isContinuous: boolean;
    graphs: {
        isRoot: boolean;
        parentPath: string[];
        isComplete: boolean;
        sdtf: SpecifyDesignTokenFormat;
    }[];
};
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.specifyapp.com/reference/sdtf-engine/sdtf-queryresult.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
